!!****m* HAPLOTYPE/m_qtlmap_haplotype_external
!!  NAME
!!    m_qtlmap_haplotype_external
!!  DESCRIPTION
!!
!!  NOTES
!!
!!  BUGS
!!
!!  HISTORY
!!
!!  SEE ALSO
!!
!!  COPYRIGHT
!!***
!! You can use this space for remarks that should not be included
!! in the documentation.
!!/
module m_qtlmap_haplotype_external
    use m_qtlmap_haplotype_data
    use m_qtlmap_haplotype_V2
    use m_qtlmap_data
    use m_qtlmap_log
    use m_qtlmap_haplotype_util, only : transmi,gammapf
    implicit none
    save


    public :: haplotype_external

    contains

!!****f* m_qtlmap_haplotype_external/haplotype_external
!! NAME
!!   haplotype_V1
!! DESCRIPTION
!!   Use the haplotype/phases for the F1 (sire and dam) given by the user (read order) [this information has been generated by an other tools than qtlmap]
!!   for each marker A B => A allele from the first chromosome (sire segment), B allele from the second chromosome
!!
!! NOTES
!!  fill arrays : pdd,ngenom,ngend,ndesc,probg,phasp,phasm,genotyp,genotypm
!!
!! SOURCE
    subroutine haplotype_external
      integer :: c,jm,kd,valnpo(nchr),i,ip,il


      allocate ( ngend(nchr,nm+1) )
      allocate ( probg(nchr,nm) )
      allocate ( ndesc(nchr,nd) )
      allocate ( genotypm(nchr,maxval(nmk),nm,2) )
      allocate ( ngenom(nchr,nm+1) )
      allocate ( phasp(nchr,np) )
      allocate ( phasm(nchr,nm) )
      allocate ( genotyp(nchr,maxval(nmk),(size(numero)),2) )

      ! structure de m_haplotype_V2
      allocate (ptfin(nchr,maxval(nmk),nd,4))
      allocate (prot(nchr,maxval(nmk),nd,4))

      call gammapf(prot)

      do c=1,nchr
       ngenom(c,1)=0
       do jm=1,nm
        probg(c,jm)=1.d0
        ngenom(c,jm+1)=ngenom(c,jm)+1
        ngend(c,jm)=ndm(jm)
        ngend(c,jm+1)=ndm(jm+1)
        do kd=ndm(jm)+1,ndm(jm+1)
          ndesc(c,kd)=kd
          do il=1,nmk(c)
            ptfin(c,il,kd,:)=prot(c,il,kd,:)
          end do
        end do

        if(correm(jm) /= 9999) then
          do il=1,nmk(c)
           genotypm(c,il,jm,1)=pheno(c,il,correm(jm),1)
           genotypm(c,il,jm,2)=pheno(c,il,correm(jm),2)
          end do !il
          phasm(c,jm)=.true.
        end if
       end do !jm

       do ip=1,np
        if(correp(ip) /= 9999) then
         do i=1,nmk(c)
            genotyp(c,i,correp(ip),1)=pheno(c,i,correp(ip),1)
            genotyp(c,i,correp(ip),2)=pheno(c,i,correp(ip),2)
         end do !i
         phasp(c,ip)=.true.
        end if
       end do !ip

      end do !c

      call setting_alloc_pdd()
      call pded_v5_optim()
      call check_recombination_sire

      deallocate (ptfin)
      deallocate (prot)




    end subroutine haplotype_external
!!***

end module m_qtlmap_haplotype_external
