!!****m* HAPLOTYPE/m_qtlmap_phase_offspring
!!  NAME
!!    m_qtlmap_phase_offspring
!!  DESCRIPTION
!!
!!  NOTES
!!
!!  BUGS
!!
!!  HISTORY
!!
!!  SEE ALSO
!!
!!  COPYRIGHT
!!***
!! You can use this space for remarks that should not be included
!! in the documentation.
!!/

module m_qtlmap_phase_offspring
    use m_qtlmap_tools
    use m_qtlmap_haplotype_data
    use m_qtlmap_data
    use m_qtlmap_log

    public :: haplotype_offspring_v1

    contains

!!****f* m_qtlmap_phase_offspring/haplotype_offspring_v1
!! NAME
!!    haplotype_offspring_v1
!! DESCRIPTION
!!  Prediction of haplotypes in offspring:
!!  assuming a known sire phase 
!!  predicting the phase of offspring using flanking markers for marker with a unknown phase
!!  (inspired from the linkphase software)
!! NOTES
!!   creation : 14/12/2010 : carole moreno
!! 
!! SOURCE
subroutine haplotype_offspring_v1
 implicit none
!A paramétricer par OLIVIER --> message de CMO

!A paramétricer par OLIVIER --> message de CMO
integer             :: mktot1, mktot2
real   (kind=dp)     :: ph1,ph2, ph
 integer :: i, j, kkd, lk, mk1, mk2, ori1, ori2, k1, k2,c, ip,jm, k,kd,nd1, nd2, nm1, nm2
  logical  , dimension (:,:),   allocatable        :: haplotyped, genotyped
 integer  :: stat

 allocate (haplotyped(size(numero),maxval(nmk)),STAT=stat)
 call check_allocate(stat,'haplotyped')
 allocate (genotyped(size(numero),maxval(nmk)),STAT=stat)
 call check_allocate(stat,'genotyped')
 
 allocate (reconstructed(nchr,size(numero),maxval(nmk)),STAT=stat)
 call check_allocate(stat,'reconstructed')

 DO c=1,nchr
!A paramétricer par OLIVIER --> message de CMO
  mktot1=1
  mktot2=nmk(c)
!A paramétricer par OLIVIER --> message de CMO
  haplotyped=.false.
  genotyped=.false.
  reconstructed=.false.
  do ip=1,np
         !print *, ip, ' pere', ' ', correp(ip)
    DO k=mktot1,mktot2 !boucle sur les marqueurs
! HYPOTHESE: on suppose que genotyp est phasé pour les pères
! Definition des variables:	* genotyped pour les pères 
!				* haplotyped pour les pères
      if (pheno(c,k,correp(ip),1)/=nmanque.and.pheno(c,k,correp(ip),2)/=nmanque            )  genotyped(correp(ip),k) =.true.
      if (genotyp(c,k,correp(ip),1)/=nmanque.and.genotyp(c,k,correp(ip),2)/=nmanque        )  haplotyped(correp(ip),k)=.true.
    ENDDO
    nm1=nmp(ip)+1
    nm2=nmp(ip+1)
    do jm=nm1,nm2
      nd1=ndm(jm)+1
      nd2=ndm(jm+1)
      do kd=nd1,nd2
        ph=0.d0;ph1=0.d0;ph2=0.d0
        if (corred(kd) == 9999 ) cycle
        genotyp(c,:,corred(kd),:)=nmanque
        IF(count(presentg(:,kd))>0) then !condition pour sélectionner les individus génotypés

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!1) PHASAGE DES PERES ET DES DESCENDANTS LORSQUE LE DESCENDANT ET LE PERE SONT GENOTYPES
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  DO k=mktot1,mktot2 !boucle sur les marqueurs
! Definition de la variable genotyped pour les descendants
   if (pheno(c,k,corred(kd),1)/=nmanque.and.pheno(c,k,corred(kd),2)/=nmanque) genotyped(corred(kd),k)=.true. 
   !print *, k, animal(kd), pheno(c,k,i,1),pheno(c,k,i,2), pere(ip), pheno(c,k,correp(ip),1), pheno(c,k,correp(ip),2)

   IF (genotyped(corred(kd),k).and.genotyped(correp(ip),k)) then ! condition sur les couple père-des génotypés
 ! Le père est homozygote
      if ((pheno(c,k,correp(ip),1)==pheno(c,k,correp(ip),2)) &
     .and.(pheno(c,k,correp(ip),1)==pheno(c,k,corred(kd),1)))  then
          genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),1)
          genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),2)
          haplotyped(corred(kd),k)=.true.
          genotyp(c,k,correp(ip),1)=pheno(c,k,correp(ip),1)
          genotyp(c,k,correp(ip),2)=pheno(c,k,correp(ip),2)
          haplotyped(correp(ip),k)=.true.
! print *, animal(kd), k,'OK'
      endif
      if ((pheno(c,k,correp(ip),1)==pheno(c,k,correp(ip),2)) &
     .and.(pheno(c,k,correp(ip),1)==pheno(c,k,corred(kd),2)))  then
          genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),2)
          genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),1)
          haplotyped(corred(kd),k)=.true.
          genotyp(c,k,correp(ip),1)=pheno(c,k,correp(ip),2)
          genotyp(c,k,correp(ip),2)=pheno(c,k,correp(ip),1)
          haplotyped(correp(ip),k)=.true.
      endif
!LE père est héterozygote l'allèle de l'haplotype 1 ou 2 est transmis
      if     ( (genotyp(c,k,correp(ip),1)/=genotyp(c,k,correp(ip),2)        )  &
        .and.  (pheno(c,k,corred(kd),1)==pheno(c,k,corred(kd),2)) &
        .and.  (genotyp(c,k,correp(ip),1)==pheno(c,k,corred(kd),1    ))) then
          genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),1)
          genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),2)
          haplotyped(corred(kd),k)=.true.
      endif
      if    (  (genotyp(c,k,correp(ip),1)/=genotyp(c,k,correp(ip),2) )   &
        .and.  (pheno(c,k,corred(kd),1)==pheno(c,k,corred(kd),2)) &
        .and.  (genotyp(c,k,correp(ip),2)==pheno(c,k,corred(kd),2  ) )) then  
          genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),2)
          genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),1)
          haplotyped(corred(kd),k)=.true.
      endif

   ENDIF ! FIN de la condition sur les couple père-des génotypés
  ENDDO ! FIn de la boucle sur les marqueurs

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! 2) PHASAGE POUR LES MARQUEURS sans phase en fonction des phases des marqueurs voisins
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 DO k=mktot1,mktot2 ! boucle marker mktot1 mktot2
    IF(.not.haplotyped(corred(kd),k))then
     mk1=0;mk2=0;ori1=0;ori2=0
     
! search for informative marker on the left side   
     if (k==mktot1) then
         mk1=0
     else
     do k1=k-1,mktot1,-1
!       if(corred(kd)==5)  print *, corred(kd), k, k1,haplotyped(corred(kd),k1), haplotyped(correp(ip),k1)
        if(haplotyped(corred(kd),k1) .and. haplotyped(correp(ip),k1)) then
         if(genotyp(c,k1,correp(ip),1)/=genotyp(c,k1,correp(ip),2))then ! search for informative marker
           if(genotyp(c,k1,corred(kd),1)==genotyp(c,k1,correp(ip),1))ori1=1
           if(genotyp(c,k1,corred(kd),1)==genotyp(c,k1,correp(ip),2))ori1=2
           mk1=k1;exit
         endif
        endif
       enddo
     endif

! search for informative marker on the right side   
     if (k==mktot2) then
         mk2=0
     else
       do k2=k+1,mktot2
        if(haplotyped(corred(kd),k2) .and. haplotyped(correp(ip),k2)) then
         if(genotyp(c,k2,correp(ip),1)/=genotyp(c,k2,correp(ip),2))then ! search for informative marker
           if(genotyp(c,k2,corred(kd),1)==genotyp(c,k2,correp(ip),1))ori2=1
           if(genotyp(c,k2,corred(kd),1)==genotyp(c,k2,correp(ip),2))ori2=2
           mk2=k2;exit
         endif
        endif
       enddo
     endif

!! reconstruction of phases for markers with unknown phase using flanking phased markers
     if(mk1/=0 .and. mk2/=0)then !mk1, mk2
        if(ori1==ori2)then ! no recombination
         ph=(1.00-(xaldane(posim(c,k)-posim(c,k1))))*(1.00-xaldane(posim(c,k2)-posim(c,k)))/(1.00-xaldane(posim(c,k2)-posim(c,k1)))
         if(ph>PROB_PHASE_DESC)then
           reconstructed(c,corred(kd),k)=.true.
           if(genotyp(c,k,correp(ip),ori1)==pheno(c,k,corred(kd),1)) then
             genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),1);genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),2)
           else
             genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),1);genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),2)
         endif
        endif
       endif

      else if(mk1/=0 .and. mk2==0)then
        ph1=1.00-xaldane(posim(c,k)-posim(c,k1))
        if(ph1>PROB_PHASE_DESC)then
          reconstructed(c,corred(kd),k)=.true.
         if(genotyp(c,k,correp(ip),ori1)==pheno(c,k,corred(kd),1))then
           genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),1);genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),2)
         else
           genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),1);genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),2)
         endif
        endif

       else if(mk1==0 .and. mk2/=0)then
         ph2=1.00-xaldane(posim(c,k2)-posim(c,k))
         if(ph2>PROB_PHASE_DESC)then
          reconstructed(c,corred(kd),k)=.true.
          if(genotyp(c,k,correp(ip),ori2)==pheno(c,k,corred(kd),1))then
            genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),1);genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),2)
          else
            genotyp(c,k,corred(kd),2)=pheno(c,k,corred(kd),1);genotyp(c,k,corred(kd),1)=pheno(c,k,corred(kd),2)
          endif
        endif

      endif !mk1, mk2

     ENDIF ! not.haplotyped

  END DO

ENDIF! fin de la condition pour sélectionner les individus génotypés
ENDDO ! end animal
ENDDO ! end mere
ENDDO ! end pere
ENDDO ! end chromosome

 deallocate(haplotyped)
 deallocate(genotyped)

end subroutine haplotype_offspring_v1
!!***


end module m_qtlmap_phase_offspring
